package com.zipcodewilmington.singlylinkedlist;

import com.sun.media.sound.AudioSynthesizerPropertyInfo;

/**
* Created by leon on 1/10/18.
*/
public class SinglyLinkedList {

    Node head;
    int size;


    public void add(int value) {
        if(head==null) {
            head= new Node(value);
            return;
        }
        Node current = head;
        while (current.next != null) {
            current = current.next;
        }

        current.next = new Node(value);
    }


    public void addFirst(int value){
        Node newHead= new Node(value);
        newHead.next= head;
        head=newHead;


    }

    public void remove(int value){
        if(head== null) return;
        if(head.value==value){
            head= head.next;
            return;
        }
        Node current= head;
        while(current.next != null){
            if(current.next.value==value){
                current.next= current.next.next;
                return;
            }
            current= current.next;
        }
    }

    public boolean contains(int element){
        if(head== null) return false;

        if(head.value== element){
            return true;
        }
        else{
            return false;
        }

    }

    public int findNodeAt(int value) {
        Node current = head;
        if(head !=null && value<= size){
            for(int i=0;i<value;i++){
                current = current.next;
            }
            return current.value;
        }
        else{
        return -1;
        }

    }

    public int size(){
        return size;
    }

    public int getNth(int index)
    {
        Node current = head;
        int count = 0;
        while (current != null)
        {
            if (count == index)
                return current.value;
            count++;
            current = current.next;
        }

    /* /* if we get to this line, the caller was asking
    for a non-existent element so we assert fail
        assert(false); */
        return 0;
    }

    //shallow copying- copying only the reference value ie memory location
    // deep copying- creats new array and copy the value of that array in a new array.
    //here we have to0 use deep copying

    public void deepCopy(int[] data , int[] value){
        if(head==null) return;
        data= new int[value.length];

        for(int i=0; i<=data.length;i++){

            data [i]= value[i];
        }


    }

    public Node  reverse(Node node){
        Node previous=null;
        Node current =node;
        Node next= null;
        while(current != null){
            next= current.next;
            current.next= previous;
            previous= current;
            current= next;
        }
        node= previous;
        return node;
    }



    public boolean isEmpty(){
        return head == null;
    }






    class Node {
        Node next;
        int value;

        public Node(int data) {
            this.value = data;
        }
    }
}


